Subject: Re: tb/cruft-packs (was Re: What's cooking in git.git (Mar 2022, #01; Thu, 3))

From: Junio C Hamano <[email-masked]>
Date: Mon, 07 Mar 2022 16:25:55 -0800

Taylor Blau <[email-masked]> writes:

> On Mon, Mar 07, 2022 at 10:06:00AM -0800, Jonathan Nieder wrote:
>> I'm excited about this work!  I just sent a quick review to the
>> design doc.
>
> Thanks! I haven't had a chance to look at the design doc, but let me
> respond quickly to this message:
>
>> Before merging to 'next', I'd be interested in two things:
>>
>>  1. Marking the feature as experimental so we can learn from experience.
>>     Clarifying what aspects we consider to be stable / set in stone and
>>     what are subject to modification.
>
> I'm not sure there is much practical benefit to marking this feature as
> experimental. The only new file format here is the .mtimes one, which
> should make it easy for us to modify the format in a
> backwards-compatible way.
>
> If there are other benefits you had in mind, I'm curious to hear them.
> But I think we should be fine to "lock in" the first version of the
> .mtimes format since we have an easy-ish mechanism to change it in the
> future.

Hmph, how?  For example, if it turns out that rewriting .mtimes file
for each object access turns out to be too much I/O churn and the
approach to use the mtime of the cruft pack for expiration of the
entire cruft pack (while ejecting objects that was used from the
cruft pack out of it to resurrect them from expiration schedule) is
more preferrable, how do we back out of from the "lock in" once this
series is unleashed to the workd?